<?php
namespace app\components;

use Yii;
use yii\base\Component;

/**
 * FactoryOrderTecno.php
 *
 * PHP Version 5.5.0
 * 
 * @category  category
 * @package   package
 * @author    Alexander Arcila <alexander.arcila@ingeneo.com.co>
 * @copyright 2015 INGENEO S.A.S.
 * @license   http://www.opensource.org/licenses/bsd-license.php BSD License
 * @version   SVN: $Id$
 * @link      http://www.ingeneo.com.co
 * 
 */

/**
 * FactoryOrderTecno.php
 *
 * // SUS COMENTARIOS AQUI
 *
 * @category  category
 * @package   package
 * @author    Alexander Arcila <alexander.arcila@ingeneo.com.co>
 * @copyright 2015 INGENEO S.A.S.
 * @license   http://www.opensource.org/licenses/bsd-license.php BSD License
 * @version   Release: $Id$
 * @link      http://www.ingeneo.com.co
 * 
 */
class FactoryOrderTecno extends Component {

    /**
     * Constructor de la clase
     * 
     * @return    void
     * @author    Alexander Arcila <alexander.arcila@ingeneo.com.co>
     * @version   SVN: $Id$
     * @copyright 2015 INGENEO S.A.S.     
     * @access    public     
     */
    public function __construct() {
        
    }

    /**
     * Funcion desctructora 
     * 
     * @return    void
     * @author    Alexander Arcila <alexander.arcila@ingeneo.com.co>
     * @version   SVN: $Id$
     * @copyright 2015 INGENEO S.A.S. 
     * @access    public     
     */
    public function __destruct() {
        
    }
    
    /**
     * Metodo que crea el XML del pedido a partir del modelo
     * Se $model no se envia o se envia NULL, la funcion 
     * calcula desde base de datos si esta existe, la carga 
     * y genera el xml
     * 
     * @param int   $idOrder Identificador de la orden
     * @param Order $model   Modelo tipo Order
     * 
     * @return boolean
     * @author    Alexander Arcila <alexander.arcila@ingeneo.com.co>
     * @copyright 2017 INGENEO S.A.S.
     * @license   http://www.opensource.org/licenses/bsd-license.php BSD License
     * @version   Release: $Id$
     * @link      http://www.ingeneo.com.co
     */
    public function createOrder($idOrder, $model = null) {
        $result = false;
        try {
            if (!empty($idOrder) && is_numeric($idOrder)) {                             
                if (is_null($model)) {                    
                    $model = app\models\Pedidos::findOne($idOrder);                    
                }
                if (!empty($model)) {                    
                    $helperOrder = new HelperOrderTECNO();
                    $arrrayHeader = $helperOrder->createHeader($model);                      
                    $items = [];
                    if(count($arrrayHeader) > 0){                        
                        $arrayOrderProduct = \app\models\Detallepedidos::find()
                                ->where(['pedido_id'=>$idOrder, 
                                    'erp'=>  \app\models\Pedidos::ERP_TECNO])
                                ->all();                              
                        if (count($arrayOrderProduct) > 0) {
                            foreach ($arrayOrderProduct as $key => $orderProduct) {
                                $items[] = $helperOrder->createItem($orderProduct, ($key+1));  
                            }
                            #insertamos el pedido ------------------------------
                            $clientTecno = new ClientTecno;                          
    //                        if($clientTecno->insertarConsecutivo($helperOrder->idPedido)){                        
    //                        }

                            if($clientTecno->insertarPedido($arrrayHeader)){
                                if($clientTecno->insertarItems($items)){
                                    $result = true;
                                }
                            } 
                        }                                               
                    }                                                                                               
                }
            }
        } catch (Exception $exc) {
            \Yii::error(__FILE__ . ':' . __LINE__ . '{'
                . print_r($exc->getMessage(), true) . '}', 'webservices');        
            $result = false;
        }
        return $result;
    }

}

?>
