<?php

namespace app\components;

use Yii;
use yii\base\Component;

/**
 * WebServicesOrder.php
 *
 * PHP Version 5.3.0
 * 
 * @category  category
 * @package   package
 * @author    Alexander Arcila <alexander.arcila@ingeneo.com.co>
 * @copyright 2014 INGENEO S.A.S.
 * @license   http://www.opensource.org/licenses/bsd-license.php BSD License
 * @version   SVN: $Id$
 * @link      http://www.ingeneo.com.co
 * 
 */

/**
 * WebServicesOrder.php
 *
 * // SUS COMENTARIOS AQUI
 *
 * @category  category
 * @package   package
 * @author    Alexander Arcila <alexander.arcila@ingeneo.com.co>
 * @copyright 2014 INGENEO S.A.S.
 * @license   http://www.opensource.org/licenses/bsd-license.php BSD License
 * @version   Release: $Id$
 * @link      http://www.ingeneo.com.co
 * 
 */
class WebServicesOrder extends Component {

    private $factoryOrder;

    /**
     * Constructor de la clase
     * 
     * @return    void
     * @author    Alexander Arcila <alexander.arcila@ingeneo.com.co>
     * @version   SVN: $Id$
     * @copyright 2014 INGENEO S.A.S.     
     * @access    public     
     */
    public function __construct()
    {
        $this->factoryOrder = new FactoryOrder();
    }

    /**
     * Funcion desctructora 
     * 
     * @return    void
     * @author    Alexander Arcila <alexander.arcila@ingeneo.com.co>
     * @version   SVN: $Id$
     * @copyright 2014 INGENEO S.A.S. 
     * @access    public     
     */
    public function __destruct()
    {
        
    }

    /**
     * Metodo para crear la conexion con el servicio
     * 
     * @return boolean
     * @author    Alexander Arcila <alexander.arcila@ingeneo.com.co>
     * @copyright 2014 INGENEO S.A.S.
     * @license   http://www.opensource.org/licenses/bsd-license.php BSD License
     * @version   Release: $Id$
     */
    private function _createConecction()
    {
        $factoryOrder = new FactoryOrder();
        $webServices = new WebServices();
        $xmlConncetion = $factoryOrder->createXmlConnection();
        $method = 'CrearConexionXML';
        $url = Yii::app()->params['paramsWs']['urlWs'];
        try {
            if($webServices->executeMethodWs($method, $url, $xmlConncetion)) {
                $response = $webServices->response;
            }
        } catch(Exception $exc) {
            //----------------------------------------------------
            Yii::log(__FILE__ . ':' . __LINE__ . ':' . __FUNCTION__
                . ':' . ' {createConecction [' . $exc->getMessage() . ']}',
                CLogger::LEVEL_ERROR, 'b2b.ws');
            //---------------------------------------------------
            return false;
        }
    }

    /**
     * Metodo para enviar los pedidos 
     * al servicio de siesa
     * 
     * @param object $objectHeader Cabecera
     * @param object $summaryItems Resumen de items
     * 
     * @return boolean
     * @author    Alexander Arcila <alexander.arcila@ingeneo.com.co>
     * @copyright 2014 INGENEO S.A.S.
     * @license   http://www.opensource.org/licenses/bsd-license.php BSD License
     * @version   Release: $Id$
     */
    public function importOrder($objectHeader, $summaryItems)
    {
        if($this->_createConecction()) {
            $xml = $this->factoryOrder->createXML($objectHeader, $summaryItems);
            if($xml) {
                try {
                    $webServices = new WebServices;
                    $method = 'ImportarXML';
                    $url = Yii::app()->params['paramsWs']['urlWs'];
                    if($webServices->executeMethodWs($method, $url, $xml)) {
                        $response = $webServices->response;
                    }
                } catch(Exception $exc) {
                    //----------------------------------------------------
                    Yii::log(__FILE__ . ':' . __LINE__ . ':' . __FUNCTION__
                        . ':' . ' {' . $exc->getMessage() . '}',
                        CLogger::LEVEL_ERROR, 'b2b.ws');
                    //---------------------------------------------------
                    return false;
                }
            }
        }
        return false;
    }

}

?>
