<?php
namespace app\components\ws_entry;

use Yii;
use yii\base\Component;

/**
 * HeaderOrder.php
 *
 * PHP Version 5.3.0
 * 
 * @category  category
 * @package   package
 * @author    Alexander Arcila <alexander.arcila@ingeneo.com.co>
 * @copyright 2018 INGENEO S.A.S.
 * @license   http://www.opensource.org/licenses/bsd-license.php  BSD License
 * @version   SVN: $Id$
 * @link      http://www.ingeneo.com.co
 * 
 */

/**
 * HeaderOrder.php
 *
 * // SUS COMENTARIOS AQUI
 *
 * @category  category
 * @package   package
 * @author    Alexander Arcila <alexander.arcila@ingeneo.com.co>
 * @copyright 2018 INGENEO S.A.S.
 * @license   http://www.opensource.org/licenses/bsd-license.php  BSD License
 * @version   Release: $Id$
 * @link      http://www.ingeneo.com.co
 * 
 */
class HeaderEntry extends Component {

    /**
     * Numero de registro
     * @var int 
     */
    public $numeroReg;

    /**
     * Tipo de registro
     * @var int 
     */
    public $tipoReg;

    /**
     * Subtipo de registro
     * @var int 
     */
    public $subTipoReg;

    /**
     * version del tipo de registro
     * @var int 
     */
    public $versionReg;

    /**
     * Compañia
     * @var int 
     */
    public $cia;

    /**
     * Indica si el numero consecutivo de docto es manual o automático
     * @var int 
     */
    public $consecAutoReg;

    /**
     * Centro de operación del documento
     * @var string
     */
    public $idCo;

    /**
     * Tipo de documento
     * @var string
     */
    public $idTipoDocto;

    /**
     * Numero de documento
     * @var int 
     */
    public $consecDocto;

    /**
     * Fecha del documento
     * @var string
     */
    public $idFecha;
    
    /**
     * Tercero
     * @var string
     */
    public $idTercero;
    
    /**
     * Clase de documento
     * @var int
     */
    public $idClaseDoct;
    
    /**
     * Estado del documento
     * @var int 
     */
    public $indEstado;
    
    /**
     * Estado de impresión del documento
     * @var int 
     */
    public $indImpresion;
    
    /**
     * Observaciones del documento
     * @var string
     */
    public $notas;
    
    /**
     * Concepto
     * @var int
     */
    public $idConcepto;
    
    /**
     * Bodea de salida
     * @var string
     */
    public $idBodegaSalida;
    
    /**
     * Bodega de entrada
     * @var string
     */
    public $idBodegaEntrada;
    
    /**
     * Documento alterno
     * @var strign 
     */
    public $doctoAlterno;
    
    /**
     * Centro de operacion base
     * @var string
     */
    public $idCoBase;
    
    /**
     * Id tipo documento base
     * @var string
     */
    public $idTipoDoctoBase;
    
    /**
     * Documento base
     * @var int
     */
    public $consecDoctoBase;
    
    /**
     * Id vehivulo
     * @var string
     */
    public $idVehiculo;
    
    /**
     * Id tercero transportador
     * @var string
     */
    public $idTerceroTransp;
    
    /**
     * Id sucursal transportadora
     * @var string
     */
    public $idSucursalTransp;
    
    /**
     * Id tercero conductor
     * @var string 
     */
    public $idTerceroConductor;
    
    /**
     * Nombre conductor
     * @var string
     */
    public $nombreConductor;
    
    /**
     * Identidicacion del conductor
     * @var int
     */
    public $identifConductor;
    
    /**
     * Numero de guia
     * @var string
     */
    public $numeroGuia;
    
    /**
     * numero de cajas
     * @var double
     */
    public $cajas;
    
    /**
     * peso
     * @var doucble
     */
    public $peso;
    
    /**
     * volumen
     * @var double 
     */
    public $volumen;
    
    /**
     * Valor merancia asculaa
     * @var double 
     */
    public $valorSeguros;
    
    /**
     * Notas transportador
     * @var stirng
     */
    public $notasTransp;



    /**
     * Listado de las variables de tipo Int con el tamaño
     * 
     * @return array
     * @author    Alexander Arcila <alexander.arcila@ingeneo.com.co>
     * @copyright 2018 INGENEO S.A.S.
     * @license   http://www.opensource.org/licenses/bsd-license.php  BSD License
     * @version   Release: $Id$
     * @link      http://www.ingeneo.com.co
     */
    public function lehgthVarsInt()
    {
        return array(
            'numeroReg' => 7,
            'tipoReg' => 4,
            'subTipoReg' => 2,
            'versionReg' => 2,
            'cia' => 3,
            'consecAutoReg' => 1,
            'consecDocto' => 8,
            'idClaseDoct' => 3,
            'indEstado' => 1,            
            'indImpresion' => 1,
            'idConcepto' => 3,
            'consecDoctoBase' => 8,
            'cajas' => 15,
            'peso' => 20,
            'volumen' => 20,
            'valorSeguros' => 20,
            
        );
    }

    /**
     * Listado de las variables de tipo String con el tamaño
     * 
     * @return array
     * @author    Alexander Arcila <alexander.arcila@ingeneo.com.co>
     * @copyright 2018 INGENEO S.A.S.
     * @license   http://www.opensource.org/licenses/bsd-license.php  BSD License
     * @version   Release: $Id$
     * @link      http://www.ingeneo.com.co
     */
    public function lehgthVarsString()
    {
        return array(
            'idCo' => 3,
            'idTipoDocto' => 3,
            'idFecha' => 8,            
            'idTercero' => 15, 
            'notas' => 255,
            'idBodegaSalida' => 5,
            'idBodegaEntrada' => 5,
            'doctoAlterno' => 15,
            'idCoBase' => 3,
            'idTipoDoctoBase' => 3,
            'idVehiculo' => 10,
            'idTerceroTransp' => 15,
            'idSucursalTransp' => 3,
            'idTerceroConductor' => 15,
            'nombreConductor' => 50,
            'identifConductor' =>15,
            'numeroGuia' => 30,
            'notasTransp' => 255,          
        );
    }

}

?>
