<?php
namespace app\components\ws_entry;

use Yii;
use yii\base\Component;

/**
 * ItemOrderOrde.php
 *
 * PHP Version 5.3.0
 * 
 * @category  category
 * @package   package
 * @author    Alexander Arcila <alexander.arcila@ingeneo.com.co>
 * @copyright 2017 INGENEO S.A.S.
 * @license   http://www.opensource.org/licenses/bsd-license.php  BSD License
 * @version   SVN: $Id$
 * @link      http://www.ingeneo.com.co
 * 
 */

/**
 * ItemOrder.php
 *
 * // SUS COMENTARIOS AQUI
 *
 * @category  category
 * @package   package
 * @author    Alexander Arcila <alexander.arcila@ingeneo.com.co>
 * @copyright 2017 INGENEO S.A.S.
 * @license   http://www.opensource.org/licenses/bsd-license.php  BSD License
 * @version   Release: $Id$
 * @link      http://www.ingeneo.com.co
 * 
 */
class ItemEntry extends Component {
    
    /**
     * Numero de registro
     * @var int
     */
    public $numeroReg;

    /**
     * Tipo de registro
     * @var int 
     */
    public $tipoReg;

    /**
     * Subtipo de registro
     * @var int 
     */
    public $subtipoReg;

    /**
     * Version del tipo de registro
     * @var int 
     */
    public $versionReg;

    /**
     * Compañía
     * @var int 
     */
    public $cia;

    /**
     * Centro de operación
     * @var string 
     */
    public $idCo;

    /**
     * Tipo de documento 
     * @var string
     */
    public $idTipoDocto;

    /**
     * Consecutivo de documento 
     * @var int 
     */
    public $consecDocto;

    /**
     * Numero de registro
     * @var int 
     */
    public $nroRegistro;
    
    /**
     * Campo adicional
     * @var string 
     */
    public $f_campo;
    
    /**
     * Bodega
     * @var string
     */
    public $idBodega;
    
    /**
     * Ubicacion auxiliar
     * @var string 
     */
    public $idUbicacionAux;
    
    /**
     * 
     * @var string
     */
    public $idLote;
    
    /**
     * Concepto
     * @var int 
     */
    public $idConcepto;
    
    /**
     * Motivo
     * @var string
     */
    public $idMotivo;
    
    /**
     * Centro de operación movimiento
     * @var string
     */
    public $idCoMovto;
    
    /**
     * Campo vacio
     * @var string
     */
    public $campo;
    
    /**
     * Centro de costo movimiento
     * @var string
     */
    public $idCcostoMovto;
    
    /**
     * Proyecto
     * @var string
     */
    public $idProyecto;
    
    /**
     * Unidad de medida
     * @var string
     */
    public $idUnidadMedida;
    
    /**
     * Cantidad base
     * @var int 
     */
    public $cantPedidaBase;
    
    /**
     * Cantidad adicional
     * @var int 
     */
    public $cant2pedida;
    
    /**
     * Costo promocional 
     * @var int 
     */
    public $precioUnitario;
    
    /**
     * Notas
     * @var string
     */
    public $notas;
    
    /**
     * Descripcion del movimiento
     * @var string
     */
    public $descVariable;
    
    /**
     * Descripcion del item
     * @var string
     */
    public $descItem;
    
    /**
     * Unidad de medida
     * @var string 
     */
    public $idUmInventario;

    /**
     * Ubicacion auxiliar
     * @var string
     */
    public $idUbicaciónAuxEnt;

    /**
     * Lote de entrada 
     * @var string 
     */
    public $idLoteEnt;
    
    /**
     * ItemOrder
     * @var int 
     */
    public $idItem;

    /**
     * Referencia item
     * @var string
     */
    public $referenciaItem;

    /**
     * Codigo de barras
     * @var string
     */
    public $codigoBarras;

    /**
     * Extension 1
     * @var string
     */
    public $idExt1Detalle;

    /**
     * Extension 2
     * @var string
     */
    public $idExt2Detalle;

    /**
     * Unidad de negocio movimiento
     * @var string
     */
    public $idUnMovto;
      
    
    /**
     * Listado de las variables de tipo Int con el tamaño
     * 
     * @return array
     * @author    Alexander Arcila <alexander.arcila@ingeneo.com.co>
     * @copyright 2017 INGENEO S.A.S.
     * @license   http://www.opensource.org/licenses/bsd-license.php  BSD License
     * @version   Release: $Id$
     * @link      http://www.ingeneo.com.co
     */
    public function lehgthVarsInt()
    {
        return array(
            //Parametros para los items ----------------------------------------
            'numeroReg' => 7,
            'tipoReg' => 4,
            'subtipoReg' => 2,
            'versionReg' => 2,
            'cia' => 3,
            'consecDocto' => 8,
            'nroRegistro' => 10,
            'idItem' => 7,
            'idConcepto' => 3,
            'cantPedidaBase' => 20,
            'cant2pedida' => 20,
            'precioUnitario' => 20           
        );
    }

    /**
     * Listado de las variables de tipo String con el tamaño
     * 
     * @return array
     * @author    Alexander Arcila <alexander.arcila@ingeneo.com.co>
     * @copyright 2017 INGENEO S.A.S.
     * @license   http://www.opensource.org/licenses/bsd-license.php  BSD License
     * @version   Release: $Id$
     * @link      http://www.ingeneo.com.co
     */
    public function lehgthVarsString()
    {
        return array(
            'idCo' => 3,
            'idTipoDocto' => 3,
            'f_campo' => 55,
            'idBodega' => 5,
            'idUbicacionAux' => 10,
            'idLote' => 15,
            'idMotivo' => 2,
            'idCoMovto' => 3,
            'campo' => 2,
            'idCcostoMovto' => 15,
            'idProyecto' => 15,
            'idUnidadMedida' => 4,
            'notas' => 255,
            'descVariable' => 2000,
            'descItem' => 40,
            'idUmInventario' => 4,
            'idUbicaciónAuxEnt' => 10,
            'idLoteEnt' => 15,
            'referenciaItem' => 50,
            'codigoBarras' => 20,
            'idExt1Detalle' => 20,
            'idExt2Detalle' => 20,
            'idUnMovto' => 20,
           
        );
    }

}

?>
