<?php

namespace app\models;

use Yii;
use yii\base\Model;
use yii\data\ActiveDataProvider;
use app\models\Requisition;
use app\models\Usrpdv;

/**
 * RequisitionSearch represents the model behind the search form of `app\models\Requisition`.
 */
class RequisitionSearch extends Requisition
{
    /**
     * @inheritdoc
     */
    public function rules()
    {
        return [
            [['id'], 'integer'],
            [['nit', 'business_name', 'code_branch', 'branch_name', 
                'id_cellar_out', 'name_cellar_out', 'id_cellar_in', 
                'name_cellar_in','num_req',  'description', 'status', 'date', 
                'total_neto', 'total_iva', 'total', 'created', 'created_by', 
                'modified', 'modified_by', 'business_unit'], 'safe'],
        ];
    }

    /**
     * @inheritdoc
     */
    public function scenarios()
    {
        // bypass scenarios() implementation in the parent class
        return Model::scenarios();
    }

    /**
     * Creates data provider instance with search query applied
     *
     * @param array $params
     *
     * @return ActiveDataProvider
     */
    public function search($params)
    {
        $query = Requisition::find();

        // add conditions that should always apply here

        $dataProvider = new ActiveDataProvider([
            'query' => $query,
        ]);

        $this->load($params);

        if (!$this->validate()) {
            // uncomment the following line if you do not want to return any records when validation fails
            // $query->where('0=1');
            return $dataProvider;
        }

        // grid filtering conditions
        $query->andFilterWhere([
            'id' => $this->id,
            'date' => $this->date,
            'created' => $this->created,
            'modified' => $this->modified,
        ]);
        
        $user = Yii::$app->user->identity->username;
      
        if($user !== self::USR_ADMIN){
            $pdvs = Usrpdv::find()->joinWith('configpdv')
                    ->where(['user_id'=>Yii::$app->user->id])->asArray()->all();
            $arrayCias = [];
            $arrayPdvs = [];
            if(count($pdvs)>0){
                foreach ($pdvs as $pdv) {
                    if(isset($pdv['configpdv'])){
                        $arrayCias[] = $pdv['configpdv']['id_cia'];
                        $arrayPdvs[] = $pdv['configpdv']['code_pdv'];
                    }
                }
                $query->andFilterWhere(['in', 'id_cia', $arrayCias])
                    ->andFilterWhere(['in', 'nit', $arrayPdvs]);
            }
        }

        $query->andFilterWhere(['like', 'nit', $this->nit])
            ->andFilterWhere(['like', 'business_name', $this->business_name])
            ->andFilterWhere(['like', 'code_branch', $this->code_branch])
            ->andFilterWhere(['like', 'branch_name', $this->branch_name])
            ->andFilterWhere(['like', 'num_req', $this->num_req])
            ->andFilterWhere(['like', 'id_cellar_out', $this->id_cellar_out])
            ->andFilterWhere(['like', 'name_cellar_out', $this->name_cellar_out])
            ->andFilterWhere(['like', 'id_cellar_in', $this->id_cellar_in])
            ->andFilterWhere(['like', 'name_cellar_in', $this->name_cellar_in])
            ->andFilterWhere(['like', 'description', $this->description])
            ->andFilterWhere(['like', 'status', $this->status])
            ->andFilterWhere(['like', 'total_neto', $this->total_neto])
            ->andFilterWhere(['like', 'total_iva', $this->total_iva])
            ->andFilterWhere(['like', 'total', $this->total])
            ->andFilterWhere(['like', 'created_by', $this->created_by])
            ->andFilterWhere(['like', 'business_unit', $this->business_unit])
            ->andFilterWhere(['like', 'modified_by', $this->modified_by]);

        return $dataProvider;
    }
}
