<?php

use yii\helpers\Html;
use yii\widgets\ActiveForm;
use kartik\select2\Select2;
use yii\web\JsExpression;
use yii\helpers\Url;
use kartik\depdrop\DepDrop;


/* @var $this yii\web\View */
/* @var $model app\models\Configpdv */
/* @var $form yii\widgets\ActiveForm */
$cia = $model->isNewRecord ? '' : $model->id_cia. ' - '.$model->name_cia;
$co = $model->isNewRecord ? '' : $model->id_co. ' - '.$model->name_co;
$cellarOut = $model->isNewRecord ? '' : $model->id_cellar_out. ' - '.$model->name_cellar_out;
$cellarIn = $model->isNewRecord ? '' : $model->id_cellar_in. ' - '.$model->name_cellar_in;
$pdv = [];
if(!$model->isNewRecord){
  $pdv = [$model->code_pdv => $model->code_pdv.' - '.$model->name_pdv];   
}

$business_unit = [];
if(!$model->isNewRecord){
  $business_unit = [$model->business_unit => $model->business_unit];   
}
?>

<div class="configpdv-form box box-solid">
    <div class="box-body">
        <?php $form = ActiveForm::begin(); ?>
        <div class="row">
            <div class="col-sm-6">
                <?= $form->field($model, 'id_cia')->widget(Select2::classname(), [    
                        'initValueText' => $cia, 
                        'options' => [
                            'placeholder' => 'Seleccione compañia...',
                        ],
                        'theme' => Select2::THEME_DEFAULT,
                        'pluginOptions' => [
                            'allowClear' => true,
                            'minimumInputLength' => 1,
                            'language' => [
                                'errorLoading' => new JsExpression("function () { return 'Buscando...'; }"),
                            ],
                            'ajax' => [
                                'url' => $url = Url::to(['configpdv/getcia']),
                                'dataType' => 'json',
                                'data' => new JsExpression('function(params) { return {q:params.term}; }')
                            ],
                            'escapeMarkup' => new JsExpression('function (markup) {return markup; }'),
                            'templateResult' => new JsExpression('function(data) { return data.text; }'),
                            'templateSelection' => new JsExpression('function (data) { '
                                    . 'tmpText = data.text;'
                                    . 'text = tmpText.split(" - ")[1];'
                                    . '$("#configpdv-name_cia").val(text); '
                                    . 'return data.text; }'),
                        ],
                        ]);?> 
                <?= $form->field($model, 'name_cia')->hiddenInput()->label(false)->error(false) ?>
            </div>
            <div class="col-sm-6">
                <?= $form->field($model, 'code_pdv')->widget(DepDrop::classname(), [                    
                        'type'=>DepDrop::TYPE_SELECT2,
                        'data'=>$pdv,
                        'select2Options'=>[
                            'initValueText' => $pdv, 
                            'theme' => Select2::THEME_DEFAULT,
                            'pluginOptions'=>[
                                'allowClear'=>true,
                                'escapeMarkup' => new JsExpression('function (markup) {return markup; }'),
                                'templateResult' => new JsExpression('function(data) { return data.text; }'),
                                'templateSelection' => new JsExpression('function (data) { '
                                    . 'tmpText = data.text;'
                                    . 'text = tmpText.split(" - ")[1];'
                                    . '$("#configpdv-name_pdv").val(text); '
                                    . 'return data.text; }'),
                            ],                            
                         ],
                        'pluginOptions'=>[
                            'initialize' => true,
                            'initDepends'=>['configpdv-id_cia'],
                            'depends'=>['configpdv-id_cia'],
                            'placeholder' => 'Seleccione...',
                            'loadingText' => 'Buscando Puntos de venta...',
                            'url' => Url::to(['getpdvs'])
                        ]
                    ]);
                    ?> 
                <?= $form->field($model, 'name_pdv')->hiddenInput()->label(false)->error(false) ?>
            </div>
        </div>
        <div class="row">
            <div class="col-sm-6">
                <?= $form->field($model, 'id_co')->widget(Select2::classname(), [    
                        'initValueText' => $co, 
                        'options' => [
                            'placeholder' => 'Seleccione CO...',
                        ],
                        'theme' => Select2::THEME_DEFAULT,
                        'pluginOptions' => [
                            'allowClear' => true,
                            'minimumInputLength' => 1,
                            'language' => [
                                'errorLoading' => new JsExpression("function () { return 'Buscando...'; }"),
                            ],
                            'ajax' => [
                                'url' => $url = Url::to(['configpdv/getlistco']),
                                'dataType' => 'json',
                                'data' => new JsExpression('function(params) { return {q:params.term}; }')
                            ],
                            'escapeMarkup' => new JsExpression('function (markup) {return markup; }'),
                            'templateResult' => new JsExpression('function(data) { return data.text; }'),
                            'templateSelection' => new JsExpression('function (data) { '
                                    . 'tmpText = data.text;'
                                    . 'text = tmpText.split(" - ")[1];'
                                    . '$("#configpdv-name_co").val(text); '
                                    . 'return data.text; }'),
                        ],
                        ]);?> 
                <?= $form->field($model, 'name_co')->hiddenInput()->label(false)->error(false) ?>
            </div>
            <div class="col-sm-6">
               <?= $form->field($model, 'business_unit')->widget(DepDrop::classname(), [                    
                    'type'=>DepDrop::TYPE_SELECT2,
                    'data'=>$business_unit,
                    'select2Options'=>[
                        'initValueText' => $business_unit, 
                        'theme' => Select2::THEME_DEFAULT,
                        'pluginOptions'=>[
                            'allowClear'=>true,
                            'escapeMarkup' => new JsExpression('function (markup) {return markup; }'),
                            'templateResult' => new JsExpression('function(data) { return data.text; }'),
    //                        'templateSelection' => new JsExpression('function (data) { '
    //                            . 'tmpText = data.text;'
    //                            . 'text = tmpText.split(" - ")[1];'
    //                            . '$("#configpdv-business_unit").val(text); '
    //                            . 'return data.text; }'),
                        ],                            
                     ],
                    'pluginOptions'=>[
                        'initialize' => true,
                        'initDepends'=>['configpdv-id_cia'],
                        'depends'=>['configpdv-id_cia'],
                        'placeholder' => 'Seleccione...',
                        'loadingText' => 'Buscando...',
                        'url' => Url::to(['get-business-unit'])
                    ]
                ]);
                ?>  
            </div>
        </div>
        <div class="row">
            <div class="col-sm-6">
                <?= $form->field($model, 'id_cellar_in')->widget(Select2::classname(), [    
                    'initValueText' => $cellarIn, 
                    'options' => [
                        'placeholder' => 'Seleccione Bodega Entrada...',
                    ],
                    'theme' => Select2::THEME_DEFAULT,
                    'pluginOptions' => [
                        'allowClear' => true,
                        'minimumInputLength' => 1,
                        'language' => [
                            'errorLoading' => new JsExpression("function () { return 'Buscando...'; }"),
                        ],
                        'ajax' => [
                            'url' => $url = Url::to(['configpdv/getcellar']),
                            'dataType' => 'json',
                            'data' => new JsExpression('function(params) { return {q:params.term}; }')
                        ],
                        'escapeMarkup' => new JsExpression('function (markup) {return markup; }'),
                        'templateResult' => new JsExpression('function(data) { return data.text; }'),
                        'templateSelection' => new JsExpression('function (data) { '
                                    . 'tmpText = data.text;'
                                    . 'text = tmpText.split(" - ")[1];'
                                    . '$("#configpdv-name_cellar_in").val(text); '
                                    . 'return data.text; }'),
                    ],
                    ]);?> 

                <?= $form->field($model, 'name_cellar_in')->hiddenInput()->label(false)->error(false) ?>
            </div>
            <div class="col-sm-6">
                <?= $form->field($model, 'id_cellar_out')->widget(Select2::classname(), [    
                    'initValueText' => $cellarOut, 
                    'options' => [
                        'placeholder' => 'Seleccione Bodega Salida...',
                    ],
                    'theme' => Select2::THEME_DEFAULT,
                    'pluginOptions' => [
                        'allowClear' => true,
                        'minimumInputLength' => 1,
                        'language' => [
                            'errorLoading' => new JsExpression("function () { return 'Buscando...'; }"),
                        ],
                        'ajax' => [
                            'url' => $url = Url::to(['configpdv/getcellar']),
                            'dataType' => 'json',
                            'data' => new JsExpression('function(params) { return {q:params.term}; }')
                        ],
                        'escapeMarkup' => new JsExpression('function (markup) {return markup; }'),
                        'templateResult' => new JsExpression('function(data) { return data.text; }'),
                        'templateSelection' => new JsExpression('function (data) { '
                                    . 'tmpText = data.text;'
                                    . 'text = tmpText.split(" - ")[1];'
                                    . '$("#configpdv-name_cellar_out").val(text); '
                                    . 'return data.text; }'),
                    ],
                    ]);?> 

                <?= $form->field($model, 'name_cellar_out')->hiddenInput()->label(false)->error(false) ?>
            </div>
        </div>
        <hr>
        <div class="form-group">
            <?= Html::submitButton(Yii::t('app', 'Save'), ['class' => 'btn btn-success']) ?>
            <?= Html::a(Yii::t('app', 'Cancel'), ['index'], ['class' => 'btn btn-default']) ?>
        </div>

        <?php ActiveForm::end(); ?>

    </div>
</div>
