<?php

use yii\helpers\Html;
use yii\grid\GridView;
use app\models\Entry;

/* @var $this yii\web\View */
/* @var $searchModel app\models\EntrySearch */
/* @var $dataProvider yii\data\ActiveDataProvider */

$this->title = Yii::t('app', 'Entries');
$this->params['breadcrumbs'][] = $this->title;
?>
<div class="entry-index box box-solid">
    <div class="box-header with-border">
        <?= Html::a(Yii::t('app', 'Create Entry'), ['create'], ['class' => 'btn btn-success']) ?>
    </div>
    <div class="box-body">
    <?php
    foreach (Yii::$app->session->getAllFlashes() as $key => $message) {
        echo '<div class="alert alert-' . $key . '">' . $message . '</div>';
    }
    ?>
    <?= GridView::widget([
        'dataProvider' => $dataProvider,
        'filterModel' => $searchModel,
        'columns' => [
            ['class' => 'yii\grid\SerialColumn'],
            [
                'class' => 'yii\grid\ActionColumn',
                'contentOptions' => ['style' => 'width:60px; white-space: normal;'],
                'visibleButtons' => [
                    'delete' => function ($data) {
                        if ($data->status != Entry::STATUS_ALLOW){
                            return true;
                        }else{
                            return false;
                        }            
                    },
                    'update' => function ($data) {
                        if ($data->status != Entry::STATUS_ALLOW){
                            return true;
                        }else{
                            return false;
                        }            
                    }
                ]
            ],
            [
                'attribute'=>'id',
                'format'=>'html',
                'value'=>function($data){
                    if ($data->status != Entry::STATUS_ALLOW){
                        return Html::a($data->id, ['update', 'id'=>$data->id]);
                    }else{
                        return $data->id;
                    }
                }
            ],
            'nit',
            'business_name',
            //'code_branch',
            //'branch_name',
            'number',
            'description:ntext',
            [
                'attribute'=>'status',
                'value'=>function($data){
                    return strtoupper($data->status);
                },
                'contentOptions' => function($data){  
                    if ($data->status != Entry::STATUS_ALLOW){
                        return ['class' => 'text-red'];
                    }else{
                        return ['class' => 'text-green'];
                    }                        
                }
            ], 
            'date'
        ],
    ]); ?>
    </div>
</div>
