<?php

use yii\helpers\Html;
use yii\widgets\DetailView;
use app\models\Entrydetail;
use yii\data\ActiveDataProvider;
use app\models\Entry;
use kartik\grid\GridView;

/* @var $this yii\web\View */
/* @var $model app\models\Entry */

$this->title = Yii::t('app', 'Entry'). ' #: '.$model->id;
$this->params['breadcrumbs'][] = ['label' => Yii::t('app', 'Entries'), 'url' => ['index']];
$this->params['breadcrumbs'][] = $this->title;

#Traemos el detalle de los items -----------------------------------------------
$query = Entrydetail::find()->where(['entry_id'=>$model->id])
        ->orderBy('description');
$data = new ActiveDataProvider([
            'query' => $query,                     
            'pagination' => false,
            'sort' => false,
        ]);
?>
<div class="entry-view box box-solid">
    <div class="box-header with-border">
        <?= Html::a(Yii::t('app', 'Nuevo'), ['create'], ['class' => 'btn btn-success']) ?>
        <?php if ($model->status != Entry::STATUS_ALLOW): ?>    
            <?= Html::a(Yii::t('app', 'Update'), 
                    ['update', 'id' => $model->id], 
                    ['class' => 'btn btn-primary'])  ?>
            <?= Html::a(Yii::t('app', 'Delete'), 
                ['delete', 'id' => $model->id], [
                'class' => 'btn btn-danger',
                'data' => [
                    'confirm' => Yii::t('app', 'Are you sure you want to delete this item?'),
                    'method' => 'post',
                ],
            ]) ?>
        <?php endif;?>
        <?= Html::a(Yii::t('app', 'Cancel'), ['index'], ['class' => 'btn btn-default']) ?>
    </div>
    <div class="box-body">
        <?= DetailView::widget([
            'model' => $model,
            'attributes' => [
                'id_cia',
                'name_cia',
                'id',
                'id_co',
                'name_co',
                'nit',
                'business_name',
                'number',
                'description:ntext',
                'id_cellar_in',
                'name_cellar_in',
                'id_cellar_out',
                'name_cellar_out',
                'status',
                'date',
                'created',
                'created_by',
                'modified',
                'modified_by',
            ],
        ]) ?>
    </div>
</div>
<div class="pedidos-view box box-solid">    
    <div class="box-header with-border">
        <h4 class="box-title">                
            <strong><?= Yii::t('app', 'Productos') ?></strong>
        </h4>
    </div>
    <div class="box-body">
        <?= GridView::widget([
        'dataProvider' => $data,  
        'responsive' => true,
        'responsiveWrap' => false,
        'showPageSummary' => false,
        'resizableColumns'=>true,
        'columns' => [
            ['class' => 'kartik\grid\SerialColumn'],
            'reference',
            [
                'attribute' => 'description',            
            ],
            [
                'attribute' => 'quantity',
                'format'=>['decimal', 0],
            ],                                        
        ],
        ]); ?>
    </div>
</div>
