<?php

use yii\helpers\Html;
//use yii\widgets\ActiveForm;
use kartik\form\ActiveForm;
use kartik\select2\Select2;
use yii\web\JsExpression;
use yii\helpers\Url;
use kartik\date\DatePicker;
use kartik\daterange\DateRangePicker;
use app\models\Requisition;

/* @var $this yii\web\View */
/* @var $model app\models\Requisition */
/* @var $form yii\widgets\ActiveForm */

$cliente = $model->isNewRecord ? '' : $model->nit.' - '.$model->business_name;
$cellarOut = $model->isNewRecord ? '' : $model->id_cellar_out.' - '.$model->name_cellar_out;
$pdvs = $model->getClient();
$cellars = $model->listCellars();
if($model->isNewRecord){
  $sucursal = [$model->code_branch => $model->code_branch.' - '.$model->branch_name]; 
}
?>
 

<div id="div-requisition" class="requisition-form box box-solid">
    <div class="box-body">
        <?php $form = ActiveForm::begin(['id'=>'form-requisition']); ?>
        <div id="div-error" style="display: none">
            <!--<button class="close" type="button" data-dismiss="alert" aria-hidden="true">×</button>-->
            <h4><i class="icon fa fa-ban"></i>Alerta!</h4>
            <div id="msg-alert"></div>
        </div>
            <?php $form = ActiveForm::begin([
                'id' => 'form-requisition',
                'action' => ['requisition/getitems'],
                'method' => 'post',
                'validationUrl' => ['requisition/validateform'],
                'validateOnSubmit' => true,
                'enableAjaxValidation' => true,
                ]); 
            ?>
        <div class="row">
            <div class="col-sm-6">
                <?= $form->field($model, 'nit')->widget(Select2::classname(), [    
                        'initValueText' => $cliente, 
                        'data' => $pdvs, 
                        'options' => [
                            'placeholder' => 'Seleccione Cliente...',
                        ],
                        'theme' => Select2::THEME_DEFAULT,
                        'pluginOptions' => [
                            'allowClear' => true,
                            'language' => [
                                'errorLoading' => new JsExpression("function () { return 'Buscando...'; }"),
                            ],
                            'escapeMarkup' => new JsExpression('function (markup) {return markup; }'),
                            'templateResult' => new JsExpression('function(data) { return data.text; }'),
                            'templateSelection' => new JsExpression('function (data) {'
                                    . ' $("#requisition-business_name").val(data.text); '
                                    . 'return data.text; }'),
                        ],
                        ])->label(Yii::t('app', 'Nit - Razon social'));?> 
                <?= $form->field($model, 'id')->hiddenInput()->label(false) ?> 
                <?= $form->field($model, 'business_name')->hiddenInput()->label(false) ?> 
                <?= $form->field($model, 'business_unit')->hiddenInput()->label(false) ?> 
            </div> 
            <div class="col-sm-6">        
                <?= $form->field($model, 'date')->widget(DatePicker::classname(), [
                        'options' => ['placeholder' => ''],
                        'type' => DatePicker::TYPE_COMPONENT_APPEND,
                        'readonly' => true,
                        'pluginOptions' => [
                            'autoclose'=>true,
                            'format' => 'yyyy-mm-dd',                            
                            'startDate' => '+0d',                            
                        ]
                    ]);?>
            </div>
        </div>
        <div class="row">
            <div class="col-sm-6">
                <?= $form->field($model, 'num_req')->textInput(['maxlength' => true]) ?>
            </div> 
            <div class="col-sm-6">                 
                <?= $form->field($model, 'cia')->textInput(['readonly'=>true]) ?> 
                <?= $form->field($model, 'id_cia')->hiddenInput()->label(false)->error(false) ?> 
                <?= $form->field($model, 'name_cia')->hiddenInput()->label(false)->error(false)  ?> 
                <?= $form->field($model, 'id_co')->hiddenInput()->label(false)->error(false) ?> 
                <?= $form->field($model, 'name_co')->hiddenInput()->label(false)->error(false)  ?> 
            </div>
        </div>
        <div class="row">    
            <div class="col-sm-6">
                <?= $form->field($model, 'id_cellar_out')->widget(Select2::classname(), [    
                    'initValueText' => $cellarOut, 
                    'data' => $cellars, 
                    'options' => [
                        'placeholder' => 'Seleccione Cliente...',
                        'id' => 'requisition-id_cellar_out',
                    ],
                    'theme' => Select2::THEME_DEFAULT,
                    'pluginOptions' => [
                        'allowClear' => true,
                            //'minimumInputLength' => 3,
                            'language' => [
                                'errorLoading' => new JsExpression("function () { return 'Buscando...'; }"),
                            ],
//                            'ajax' => [
//                                'url' => $url = Url::to(['requisition/getcellar']),
//                                'dataType' => 'json',
//                                'data' => new JsExpression('function(params) { return {q:params.term}; }')
//                            ],
                        'escapeMarkup' => new JsExpression('function (markup) {return markup; }'),
                        'templateResult' => new JsExpression('function(data) { return data.text; }'),
                        'templateSelection' => new JsExpression('function (data) { '
                            . 'tmpText = data.text;'
                            . 'text = tmpText.split(" - ")[1];'
                            . '$("#requisition-name_cellar_out").val(text); '
                            . 'return data.text; }'),
                    ],
                    ])->label(Yii::t('app', 'Bodega Salida'));?>
                <?= $form->field($model, 'name_cellar_out')->hiddenInput()->label(false) ?>
            </div>
            <div class="col-sm-6">
                <?= $form->field($model, 'cellar_in')->textInput(['readonly' => true]) ?>
                <?= $form->field($model, 'id_cellar_in')->hiddenInput()->label(false)->error(false) ?>
                <?= $form->field($model, 'name_cellar_in')->hiddenInput()->label(false) ?>
            </div>            
        </div>
        <div class="row">    
            <div class="col-sm-6">
                <?=  $form->field($model, 'date_range', [
                            //'addon'=>['append'=>['content'=>'<i class="glyphicon glyphicon-calendar kv-dp-icon"></i>']],
                            'options'=>['class'=>'drp-container mb-2']
                    ])->widget(DateRangePicker::classname(), [
                            'useWithAddon'=>true,
                            'readonly' => true,
                            'hideInput' => true,
                            //'presetDropdown'=>true,
                            'startAttribute' => 'datetime_start',
                            'endAttribute' => 'datetime_end',
                            'convertFormat'=>true,
                    ]); 
                ?>
            </div>
            <div class="col-sm-6">
                <?= $form->field($model, 'percentage')->textInput() ?>
            </div>
        </div>
        <div class="row">    
            <div class="col-sm-12">
                <?= $form->field($model, 'description')->textInput(['maxlength' => true]) ?>
            </div>            
        </div>
        <div id="buttom" class="form-group">
            <?= Html::submitButton('<i class="fa fa-search"></i> '
                    .Yii::t('app', 'Search'), ['class' => 'btn btn-primary', 
						'id' => 'btnSearch', 'name' => 'btnSearch']) ?>
            <?= Html::a('<i class="fa fa-reply"></i> '
                    .Yii::t('app', 'Cancel'), ['index'], ['class' => 'btn btn-default']) ?>
        </div>
		
        <?php ActiveForm::end(); ?>
        <div id="form-items"></div>		
    </div>
</div>




<script type="text/javascript">

	$(document).ready(function () {
        $('form#form-requisition').on('beforeSubmit', function (){
            var form = $(this);
            // return false if form still have some validation errors
            if (form.find('.has-error').length) {
                return false;
            }
            // submit form -----------------------------------------------------
            getItems(form);
            return false;
        });
    });
	
    $(document).ready(function(){
        <?php if(!$model->isNewRecord): ?>
            cleanError();
            getInfopdv();
            //getItems();
        <?php endif; ?>
    });
    
    $('#requisition-nit').change(function(){               
        cleanError();
        getInfopdv();
    });        
    
    /**
     * Presenta el boton liquidar
     * @returns {undefined}
     */
    function showBtnLiquidar(){
        $("#btnLiquidar").show();
    }
    
    /**
     * Esconde el boton liquidar
     * @returns {undefined}
     */
    function hideBtonLiquidar(){
        $("#btnLiquidar").hide();
    }
    
    /**
     * Muestra el icono de cargando
     * @returns {undefined}
     */
    function showLoading(){        
        $("#div-requisition").append('<div class="overlay"><i class="fa fa-refresh fa-spin"></i></div>');
    }
    
    /**
     * Esconde el icono de cargando
     * @returns {undefined}
     */
    function hideLoading(){
        $(".overlay").remove();
    }
    
    /**
     * Muestra los errores
     * @returns {undefined}
     */
    function showError(msg) {
        if (msg === '' || !msg || msg === null) {            
            $("#msg-alert").html('');
            $("#div-error").removeClass('alert alert-danger alert-dismissible');
            $("#div-error").hide();            
        } else {            
            $("#msg-alert").html(msg);            
            $("#div-error").addClass('alert alert-danger alert-dismissible');
            $("#div-error").show();
            $('html, body').stop().animate({
                scrollTop: $("#div-error").offset().top - 50
            }, 1000);
        }
    }
    
    /**
     * Esconde los errores
     * @returns {undefined}
     */
    function cleanError(){
        showError('');
    }
    
    /**
     * Retorna los productos      
     * @returns string
     */
    function getInfopdv() { 
        nit = $("#requisition-nit").val();  
        business_name = $( "#requisition-nit option:selected" ).text();
        $.ajax({url: '<?= Url::to(['getinfopdv']) ?>',
            type: "post",
            data: {nit: nit, business_name: business_name},
            //dataType: 'json',
            error : function(){                
                showError('<?= Yii::t('app', 'Error bodega entrada')?>');
            },
            success: function(data) {  
                $("#requisition-id_co").val(data.id_co);    
                $("#requisition-name_co").val(data.name_co);
                $("#requisition-id_cia").val(data.id_cia);    
                $("#requisition-name_cia").val(data.name_cia);
                $("#requisition-cia").val(data.id_cia+' - '+data.name_cia);
                $("#requisition-id_cellar_in").val(data.id_cellar_in);    
                $("#requisition-name_cellar_in").val(data.name_cellar_in);    
                $("#requisition-cellar_in").val(data.id_cellar_in+' - '+data.name_cellar_in); 
                //$("#requisition-id_cellar_out").val(data.id_cellar_out);    
                //$("#requisition-name_cellar_out").val(data.name_cellar_out); 
                console.log(data.id_cellar_out+'-'+data.name_cellar_out);
                $("#requisition-business_unit").val(data.business_unit); 
                //$('#requisition-id_cellar_out').select2('results', {id: 'PV301', text: 'Lorem Ipsum'});
                $('#requisition-id_cellar_out').val(data.id_cellar_out);
                $('#requisition-id_cellar_out').trigger('change');
                //getItems();
            }
        });        
    }
    
    /**
     * Retorna los productos      
     * @returns string
     */
    function getItems(form) { 
        pedido = null;
        <?php if(!$model->isNewRecord): ?>
            pedido = <?= $model->id?>;
        <?php endif; ?>        
        cleanError();
        showLoading();
        $("#form-items").html(' ');
        ancho = $(document).width();
		withPage = $(document).width();
		
        $.ajax({url: '<?= Url::to(['getitems']) ?>',
            type: "post",
            //dataType: 'json',
			data   : form.serialize()+"&withPage="+withPage+"&pedido="+pedido,
            error : function(){                
			
                showError('<?= Yii::t('app', 'Error Productos')?>');
                hideLoading();
            },
            success: function(data) {                
                $("#form-items").html(data);
                showBtnLiquidar();
                $('.amount').focus(function() {                    
                    if($(this).attr('readonly') != "readonly" ){
                        defaultText = $(this).val();
                        $(this).val('');
                        var stringTemp = $(this).attr('id');
                        stringSplit = stringTemp.split('_');
                        iden = stringSplit[2];
                        $('#' + iden + '_tr').attr('class', 'danger');
                        //$('#' + iden + '-sub').html(0);
                        //$('#' + iden + '-sub-iva').html(0);
                        //$('#' + iden + '_sub_input_id').val(0);
                    }                     
                });    
                hideLoading();
            }
        });        
    }
    
    /**
     * Valida si se ingreso alguna cantidad 
     * @returns {undefined}     
     */
    function valItemSeleciconado(){
        var validador = false;
        $(".amount").each(function() {
            val = $(this).val();
            if (val > 0) {
                validador = true;
            }
        });        
        if(validador == false){
            showError('Seleccione una referencia');
            return false;
        }
        return true;
    }
    
    /**
     * Esconde los registros que no tengan cantidad             
     */
    function hideInputsEmpty(){
        // Recalcular cantidad
        let countProducts = 0;

        $('#requisition-nit').select2("enable",false);
        $('#requisition-code_branch').select2("enable",false);
        $('.accordion-content').each(function() { 
            
            var sw = 0;
            var data = $(this).find('.amount');            
            $(data).each(function() {
                val = $(this).val();                         
                stringTemp = $(this).attr('id');                 
                stringSplit = stringTemp.split('_');
                iden = stringSplit[2];
                //Validamos si tiene cantidad y escondemos los que no tengan ---                
                if (val == 0 || !this.value) {                                        
                    //Escondemos la fila ---------------------------------------
                    $('#' + iden + '_tr').hide();
                    $('#' + 'addInfo-' + iden).hide();                    
                    //Deshabilitamos cada input de la fila ---------------------
                    $('#' + iden + '_id').prop('disabled', 'disabled');
                    $('#' + iden + '_description').prop('disabled', 'disabled');
                    $('#orp_amount_' + iden ).prop('disabled', 'disabled');
                    $('#' + iden + '_inv').prop('disabled', 'disabled');
                    $('#' + iden + '_inv').prop('disabled', 'disabled');
                    $('#' + iden + '_cat').prop('disabled', 'disabled');
                    $('#' + iden + '_amount_request').prop('disabled', 'disabled');
                    $('#' + iden + '_unt_price').prop('disabled', 'disabled');
                    $('#' + iden + '_iva').prop('disabled', 'disabled');
                    $('#' + iden + '_unt_price_iva').prop('disabled', 'disabled');
                    $('#' + 'notas_' + iden ).prop('disabled', 'disabled');
                }else{
                    countProducts++;
                    sw = 1;                    
                    $('#' + 'plus_' + iden).hide();
                    $('#' + iden + '_tr').show();
                    $('#' + 'addInfo-' + iden).show();
                    $('#' + iden + '_tr').removeAttr('class');
                    $(this).attr('readonly', 'readonly');
                    $('#' + 'notas_' + iden ).attr('readonly', 'readonly');
                }
                //$('#' + parentTr).removeAttr('class');
            });            
            //Escondemos la categoria ------------------------------------------ 
            if (sw === 0) {
                $(this).hide();                
            }else{
                var content = $(this).find('.panel-collapse');
                content.attr('aria-expanded', 'true');                    
                content.attr('style', '');                    
                content.addClass('in');
            }

            // Actualizar label cantidad total de productos
            $("#countProducts").text(countProducts)
        });
    }
    
    /**
     * Muestra las pestañas de cada categoria para seleccionar nuevos produstos
     * @returns {undefined}     
     */
    function showTabs(){
        $('.accordion-content').each(function() { 
            var sw = 0;
            var data = $(this).find('.amount');            
            $(data).each(function() {
                val = $(this).val();                                
                stringTemp = $(this).attr('id');                 
                stringSplit = stringTemp.split('_');
                iden = stringSplit[2];                
                //Mostramos la fila --------------------------------------------
                $('#' + iden + '_tr').show();
                $('#' + 'plus_' + iden).show();
                //Deshabilitamos cada input de la fila -------------------------
                $('#' + iden + '_id').removeAttr('disabled'); 
                $('#' + iden + '_description').removeAttr('disabled'); 
                $('#orp_amount_' + iden ).removeAttr('disabled'); 
                $('#' + iden + '_inv').removeAttr('disabled'); 
                $('#' + iden + '_inv').removeAttr('disabled'); 
                $('#' + iden + '_cat').removeAttr('disabled'); 
                $('#' + iden + '_amount_request').removeAttr('disabled'); 
                $('#' + iden + '_unt_price').removeAttr('disabled'); 
                $('#' + iden + '_iva').removeAttr('disabled'); 
                $('#' + iden + '_unt_price_iva').removeAttr('disabled'); 
                $(this).removeAttr('readonly');  
                $('#' + 'addInfo-' + iden).removeAttr('style'); 
                $('#' + 'notas_' + iden ).removeAttr('disabled');
                $('#' + 'notas_' + iden ).removeAttr('readonly');
                $('#' + 'addInfo-' + iden).attr('style', 'height: 0px;');  
            });            
            //Mostramos la categoria -------------------------------------------
            $(this).show(); 
            var content = $(this).find('.panel-collapse');
            content.attr('aria-expanded', 'false');                    
            content.attr('style', 'height: 0px;');                    
            content.removeClass('in');            
        });
    }    
        
    /**
     * Funcion que habilita la edicion de la informacion
     * @returns {undefined}     
     * */
    function edit() {
        showTabs();
        $('#requisition-nit').select2("enable");
        //$('#requisition-code_branch').select2("enable",true);
        //$('#summary').hide();
        buttomSend('liquidar', '<?= Url::to(['changebuttom']) ?>');
    }
    
    /**
     * 
     * @param {type} typeButtom
     * @param {type} url
     * @returns {undefined}
     */
    function buttomSend(typeButtom, url) {   
		$("#buttom").hide();
        $.ajax({url: url,
            type: "post",
            async: false,
            data: {type: typeButtom},
            success: function(data) {
                $("#buttom-send").html(data);
            }});
    }        
    
    /**
     * Selecciona las referencias con cantidades y muestra resumen del pedido
     * @returns {undefined}
     */
    function liquidar() {        
        showLoading();
		$('#liquidate').hide();
        $('#btn-send').show();
        //Validamos seleciconar al menos una referencia ------------------------
        if(valItemSeleciconado()){            
            //Ocultamos los input sin valor ------------------------------------            
            hideInputsEmpty();
            cleanError();
            //summary();
            buttomSend('send', '<?= Url::to(['changebuttom']) ?>'); 
            hideLoading();
        }else{
            hideLoading();
        }
    }
    
    /**
     * funcion que realiza los calculos de cada item 
     * @param {type} id
     * @param {type} ident
     * @returns {Boolean}     */                
    function calculate(id, ident) {        
        stringQuantity = $('#' + id).val();                 
        quantity = stringQuantity.replace(/[^0-9\.]/g, '');
        tempQuantity = parseInt(quantity);
        tempInvent = parseInt($('#' + ident + "_inv").val());
        invent = $('#' + ident + "_inv").val();
        priceUnt = $('#' + ident + "_unt_price").val();
        priceUntIva = $('#' + ident + "_unt_price_iva").val();
        valUnt = quantity * priceUnt;
        valUntIva = quantity * priceUntIva;
        //evita desborde de los precios ----------------------------------------
        if (valUnt.toString().length > 9 || valUntIva.toString().length > 9) {
            quantity = quantity.substr(0, 5);
            valUnt = quantity * priceUnt;
            valUntIva = quantity * priceUntIva;
            alert('El Número es muy extenso, por favor verifique la cantidad');
        }
        //Senala los items con cantidades en cero o vacio ----------------------
        if (quantity > 0) {
            $('#' + ident + '_tr').removeClass("danger");
            $('#' + ident + '_tr').attr('class', 'success');
        } else {
            $('#' + ident + '_tr').attr('class', 'danger');
        }
        //Sumatorias y formateo de resultados ----------------------------------
        $('#' + id).val(quantity);
        $('#' + ident + '_amount_request').val(tempQuantity);
        $('#' + ident + '_amount_request').number(tempQuantity);
        $('#' + ident + '-sub').html(valUnt);
        $('#' + ident + '-sub').number(valUnt);
        $('#' + ident + '_sub_input_id').val(valUnt);
        $('#' + ident + '_sub_input_id').number(valUnt);
        $('#' + ident + '-sub-iva').html(valUntIva);
        $('#' + ident + '-sub-iva').number(valUntIva);
        return false;
    }
    
    /**
     * Suma los datos de una columna en especifico 
     * @param {string} classDiv
     * @returns {suma|Number}     
     */
    function sumaColumn(classDiv) {
        suma = 0;
        $('' + classDiv + '').each(function() {
            val = jQuery(this).html();
            valInt = val.replace(/,/gi, '');
            suma = suma + parseInt(valInt);
        });
        return suma;
    }
    
    /**
     * Metodo para sacar la relacion 
     * de los calculos
     * @returns {undefined}     
     */
    function summary() {
        //Calculamos el subtotal de siesa --------------------------------------
        subUnt = sumaColumn('.sub_siesa');
        $('#total_neto_jdh').html('$ ' + $.number(subUnt));
        subUntIva = sumaColumn('.sub_iva_siesa');        
        $('#total_jdh').html('$ ' + $.number(subUntIva));
        totalIva = subUntIva - subUnt;        
        $('#total_iva_jdh').html('$ ' + $.number(totalIva));
        //Calculamos el subtotal de tecno --------------------------------------
        subUnt = sumaColumn('.sub_tecno');        
        $('#total_neto_tecno').html('$ ' + $.number(subUnt));
        subUntIva = sumaColumn('.sub_iva_tecno');        
        $('#total_tecno').html('$ ' + $.number(subUntIva));
        totalIva = subUntIva - subUnt;        
        $('#total_iva_tecno').html('$ ' + $.number(totalIva));
        //Calculamos el total del pedido ---------------------------------------
        subUnt = sumaColumn('.sub');        
        $('#total_neto').html('$ ' + $.number(subUnt));
        subUntIva = sumaColumn('.sub_iva');        
        $('#total').html('$ ' + $.number(subUntIva));
        totalIva = subUntIva - subUnt;        
        $('#total_iva').html('$ ' + $.number(totalIva));
        //$('#summary').show();
    }                                                 
    
    /**
     * Funcion para salir  
     * @returns {undefined}     
     */
    function exitOrder() { 
        inputStatus = '<?= Html::hiddenInput('status', Requisition::STATUS_PENDING) ?>';
        $('#div-status').html(inputStatus);
        save();
    }

    /**
     * Funcion que permite habilitar los campos 
     * para guardar la informacion
     * @returns {Boolean}
     */
    function save() {
        showLoading();
        //enabledForm('form-requisition');
        hideInputsEmpty();
        submitForm('form-requisition-products');
        hideLoading();
    }
         
    /**
     * funcion para autorizar las peticiones
     * @returns {Boolean}
     */
    function allowOrder() {
        showLoading();
        inputStatus = '<?= Html::hiddenInput('status', Requisition::STATUS_ALLOW) ?>';
        $('#div-status').html(inputStatus);               
        //enabledForm('form-requisition');
        hideInputsEmpty();
        submitForm('form-requisition-products');
        hideLoading();
    }  

    /**
     * funcion para solicitar autorizacion de las peticiones
     * @returns {Boolean}
     */
    function changetStatus() {
        showLoading();
        inputStatus = '<?= Html::hiddenInput('status', Requisition::STATUS_PENDING)?>';
        $('#div-status').html(inputStatus);
        enabledForm('form-requisition');
        hideInputsEmpty();
        submitForm('form-requisition');
    }       


    function enabledForm(idForm) {
        $('#' + idForm).find('input, textarea, select').removeAttr('disabled');
        $('#buttom').find('button').attr('disabled', 'disabled');
    }

    function submitForm(idForm) {
        form = $('#' + idForm);
        form.submit();
    }
</script>
