<?php
use yii\helpers\ArrayHelper;
use yii\bootstrap\Html;
use app\models\Requisitiondetail;
use yii\widgets\ActiveForm;

#Decalramos modelo detalle pedidos para extraer labels -------------------------
$dtlPedidos = new Requisitiondetail;

#Traemso los datos si el pedido ya existe --------------------------------------
$productosAntSIESA = [] ;   
if(!empty($pedido) && is_numeric($pedido)){
    $productosAnt = Requisitiondetail::find()->where(['requisition_id'=>$pedido])->asArray()->all();
    $productosAntSIESA = ArrayHelper::index($productosAnt, 'reference');
}

# Separamso los productos por ERP ----------------------------------------------
$productosERP = ArrayHelper::index($listProduct, 'referencia' , ['erp']);
$productosSIESA = isset($productosERP['siesa']) ? $productosERP['siesa'] : [] ;
$countProducts = count($productosSIESA);

# Traemos las categorias  ------------------------------------------------------
$listCategorySIESA = ArrayHelper::index($productosSIESA, 'referencia', ['categoria_id']);

# Validamos las columnas a mostrar segun la resolucion de la pantalla ----------
$shReferencia = '';
$shUnidadMedida = '';
$shCantidad = 0;
$shDescripcion = $shReferencia;
if($ancho < 600){
    $shUnidadMedida  = $shReferencia = 'display: none';
}
if($ancho >= 600 && $ancho <= 900){
    $shReferencia = 'display: none';
}

?>
    
<?php if(count($listCategorySIESA) > 0 ): ?> 
    <?php if(count($listCategorySIESA) > 0): ?>

	<?php

        $action = ['requisition/create'];

        if(!empty($pedido) && is_numeric($pedido)){
           $action = ['requisition/update', 'id' => $pedido];
        }

        $form = ActiveForm::begin([
            'id' => 'form-requisition-products',
            'action' => $action,
            'method' => 'post',
        ]);
     ?>


    <div class="box-body">
        <h4 class="box-title">
            <strong><?= Yii::t('app', 'Productos') ?></strong>
            <div style="float: right;">
                <span>Total <strong id="countProducts"><?= $countProducts ?></strong> productos</span>
            </div>
        </h4>
        <div class="box-group" id="accordion-siesa">
        <?php foreach($listCategorySIESA as $keyCategoria => $data): ?>
            <?php $firstData = current($data)?>                      
            <div class="panel box box-primary accordion-content" style="margin-bottom: -2px;">
                <div class="box-header with-border">
                    <h4 class="box-title">
                        <a data-toggle="collapse" data-parent="#accordion" 
                           href="#collapse-siesa-<?= $keyCategoria ?>" aria-expanded="false" class="collapsed">
                            <?= $firstData['nombre_categoria'] ?>
                        </a>
                    </h4>
                </div>
                <div id="collapse-siesa-<?= $keyCategoria ?>" class="panel-collapse collapse" 
                     aria-expanded="false" style="height: 0px;">
                    <div class="box-body table-responsive">
						<small>
                        <table class="table table-striped" >
                            <thead>
                                <tr>
                                    <th style="<?= $shReferencia ?>"><?= $dtlPedidos->getAttributeLabel('Referencia')?></th>
                                    <th style="<?= $shDescripcion ?>"><?= $dtlPedidos->getAttributeLabel('descripcion')?></th>
                                    <th style="<?= $shUnidadMedida ?>"><?= $dtlPedidos->getAttributeLabel('unidad_medida')?></th>
									<th><?= Yii::t('app', 'Cant Inventario') ?></th>
									<th><?= Yii::t('app', 'Cant Pedida') ?></th>
                                    <th style="<?= $shCantidad ?>"><?= Yii::t('app', 'Cant sugerida') ?></th>
                                </tr>
                                <?php 
                                foreach($data as $value) { 
                                    $cantidad = 0;
                                    $precio = 0;
                                    $precioIva = 0;
                                    $iva = 0;
                                    $subSinIva = 0;
                                    $subIva = 0;
                                    $class = '';                                        
                                    $idItem = '';
                                    if(isset($productosAntSIESA[$value['referencia']])){
                                        $itemAnt = $productosAntSIESA[$value['referencia']]; 
                                        $idItem = $itemAnt['id'];   
                                        $cantidad = $itemAnt['quantity'];                                             
                                        $class = 'class="success"';                                            
                                    }
									//if($value['cantidad_disponible'] >0 ){
										$tmpQuantity = $value['cantidad_disponible'] - $value['cantidad_pedida'];
										$cantidad = ($tmpQuantity < 0) ? abs($tmpQuantity) : 0; 
									//}
									if(is_numeric($percentage) && $percentage >0 ){
										$cantidad = ($cantidad * ($percentage/100) + $cantidad); 
									}
                                    // -------------------------------------                                                                                                                        
                                    $id = 'siesa-'.$value['referencia'];
                                    $html = '';
                                    $html .= '<tr id="' . $id . '_tr" '.$class.'>';                                        
                                    $html .= '<td id="' . $id . '_ref" class="reference" style="'.$shReferencia.'">'
                                        . $value['referencia'] .'</td>';
                                    $html .= '<td id="' . $id . '_des" class="description" style="'.$shDescripcion.'">'
                                        . Html::hiddenInput($id . '_description',
                                            $value['descripcion'],
                                            ['id' => $id . '_description'])
                                        . $value['descripcion'] . '</td>';
                                    $html .= '<td id="' . $id . '_ref" class="unidad_medida" style="'.$shUnidadMedida.'">'
                                        . $value['unidad_medida'] .'</td>';
									$html .= '<td id="' . $id . '_ref" class="reference" style="'.$shReferencia.'">'
                                        . $value['cantidad_disponible'] .'</td>';
									$html .= '<td id="' . $id . '_ref" class="reference" style="'.$shReferencia.'">'
                                        . $value['cantidad_pedida'] .'</td>';
                                    $html .='<td style="'.$shCantidad.'">' 
                                        . Html::textInput("cantidad[$id]", $cantidad,
                                            [                                                
                                            'id' => 'orp_amount_'.$id,
                                            'class' => 'amount form-control',
                                            "onkeyup" => "calculate(this.id, '" . $id . "')"
                                            ]) .
                                        Html::hiddenInput($id . '_inv', $value['cantidad_disponible'],
                                            array(
                                            'id' => $id . '_inv')) .
                                        Html::hiddenInput($id . '_cat', $value['categoria_id'],
                                            array(
                                            'id' => $id . '_cat')) .
                                        Html::hiddenInput($id . '_amount_request', '',
                                            array(
                                            'id' => $id . '_amount_request'))
                                        . '</td>';
                                    $html .= '</tr>'; 
                                    echo $html;
                                }                                
                                ?>
                            </thead>
                        </table>
						</small>
                    </div>
                </div>
            </div>                      
        <?php endforeach; ?>    
        </div>
		<br>
		<div id="liquidate" class="form-actions form-group">
			<?= Html::button(Yii::t('app', 'Liquidar'), 
				['id'=>'btnLiquidar',
				'class' => 'btn btn-primary', 
				'onClick' => 'liquidar()','style'=>'display:none']) ?>        
			<?= Html::a(Yii::t('app', 'Cancel'), ['index'], ['class' => 'btn btn-default']) ?>
		</div>
		<?= $form->field($model, 'id')->hiddenInput()->label(false)->error(false); ?>
		<?= $form->field($model, 'nit')->hiddenInput()->label(false)->error(false); ?>
		<?= $form->field($model, 'business_name')->hiddenInput()->label(false)->error(false); ?>
		<?= $form->field($model, 'date')->hiddenInput()->label(false)->error(false); ?>
		<?= $form->field($model, 'num_req')->hiddenInput()->label(false)->error(false); ?>
		<?= $form->field($model, 'id_cellar_out')->hiddenInput()->label(false)->error(false); ?>
		<?= $form->field($model, 'name_cellar_out')->hiddenInput()->label(false)->error(false); ?>
		<?= $form->field($model, 'cellar_in')->hiddenInput()->label(false)->error(false); ?>
		<?= $form->field($model, 'id_cellar_in')->hiddenInput()->label(false)->error(false); ?>
		<?= $form->field($model, 'name_cellar_in')->hiddenInput()->label(false)->error(false); ?>
		<?= $form->field($model, 'date_range')->hiddenInput()->label(false)->error(false)  ?>
		<?= $form->field($model, 'datetime_start')->hiddenInput()->label(false)->error(false)  ?>
		<?= $form->field($model, 'datetime_end')->hiddenInput()->label(false)->error(false)  ?>
		<?= $form->field($model, 'percentage')->hiddenInput()->label(false)->error(false)  ?>
		<?= $form->field($model, 'description')->hiddenInput()->label(false)->error(false)  ?>
		<?= $form->field($model, 'cia')->hiddenInput()->label(false)->error(false) ?> 
		<?= $form->field($model, 'id_cia')->hiddenInput()->label(false)->error(false) ?> 
		<?= $form->field($model, 'name_cia')->hiddenInput()->label(false)->error(false)  ?> 
		<?= $form->field($model, 'id_co')->hiddenInput()->label(false)->error(false) ?> 
		<?= $form->field($model, 'name_co')->hiddenInput()->label(false)->error(false)  ?>
        <?= $form->field($model, 'business_unit')->hiddenInput()->label(false)->error(false); ?>
		<div id="buttom-send"></div>
		<div id="div-status"></div>
    </div>
	<?php ActiveForm::end(); ?>
    <?php endif; ?>   
<?php else: ?>
    <div class="alert alert-danger">
        No se encontraron productos 
    </div>        
<?php endif; ?>
