<?php

use yii\helpers\Html;
use yii\widgets\DetailView;
use app\models\Requisitiondetail;
use yii\data\ActiveDataProvider;
use app\models\Requisition;
use kartik\grid\GridView;

/* @var $this yii\web\View */
/* @var $model app\models\Requisition */

$this->title = Yii::t('app', 'Requisition'). ' #: '.$model->id;
$this->params['breadcrumbs'][] = ['label' => Yii::t('app', 'Requisitions'), 'url' => ['index']];
$this->params['breadcrumbs'][] = $this->title;

#Traemos el detalle de los items -----------------------------------------------
$query = Requisitiondetail::find()->where(['requisition_id'=>$model->id])
        ->orderBy('description');
$data = new ActiveDataProvider([
            'query' => $query,                     
            'pagination' => false,
            'sort' => false,
        ]);
?>
<div class="requisition-view box box-solid">
    <div class="box-header with-border">
    <p>
        <?= Html::a(Yii::t('app', 'Nuevo'), ['create'], ['class' => 'btn btn-success']) ?>
        <?php if ($model->status != Requisition::STATUS_ALLOW): ?>    
            <?= Html::a(Yii::t('app', 'Update'), 
                    ['update', 'id' => $model->id], 
                    ['class' => 'btn btn-primary']) ?>
            <?= Html::a(Yii::t('app', 'Delete'), 
                ['delete', 'id' => $model->id], [
                'class' => 'btn btn-danger',
                'data' => [
                    'confirm' => Yii::t('app', 'Are you sure you want to delete this item?'),
                    'method' => 'post',
                ],
            ])?>
        <?php endif;?>
        <?= Html::a(Yii::t('app', 'Cancel'), ['index'], ['class' => 'btn btn-default']) ?> 
    </p>
    </div>
    <div class="box-body">
        <?php
            if(isset($_GET['msg']) && count($_GET['msg'])>0){
                echo '<div class="alert alert-' . $_GET['msg']['tipo'] . '">'
                        . '<button class="close" type="button" '
                        . 'data-dismiss="alert" aria-hidden="true">×</button>' 
                        . $_GET['msg']['msg'] . '</div>';
            }                            
        ?>
    <?= DetailView::widget([
        'model' => $model,
        'attributes' => [
            'id',
            'nit',
            'business_name',
            //'code_branch',
            //'branch_name',
            'num_req',
            'name_cellar_out',
            'name_cellar_in',
            'description:ntext',
            'status',
            'date',
            //'total_neto',
            //'total_iva',
            //'total',
            'created',
            'created_by',
            'modified',
            'modified_by',
        ],
    ]) ?>
    </div>
</div>
<div class="pedidos-view box box-primary">    
    <div class="box-header with-border">
        <h4 class="box-title">                
            <strong><?= Yii::t('app', 'Productos') ?></strong>
        </h4>
    </div>
    <div class="box-body">

    <?= GridView::widget([
    'dataProvider' => $data,  
    'responsive' => true,
    'responsiveWrap' => false,
    'showPageSummary' => false,
    'resizableColumns'=>true,
    'columns' => [
        ['class' => 'kartik\grid\SerialColumn'],
        'reference',
        [
            'attribute' => 'description',            
        ],
        [
            'attribute' => 'quantity',
            'format'=>['decimal', 0],
        ],                                        
    ],
    ]); ?>
    </div>
</div>
