<?php

use yii\helpers\Html;
use yii\grid\GridView;

/* @var $this yii\web\View */
/* @var $searchModel app\models\UsrpdvSearch */
/* @var $dataProvider yii\data\ActiveDataProvider */

$this->title = Yii::t('app', 'Usrpdvs');
$this->params['breadcrumbs'][] = $this->title;
$model = new \app\models\Usrpdv;
$users  = $model->getUsersDrop();
$pdvs  = $model->getPdvsDrop();
?>
<div class="usrpdv-index box box-solid">
    <div class="box-body">
    <?php // echo $this->render('_search', ['model' => $searchModel]); ?>

    <p>
        <?= Html::a(Yii::t('app', 'Create Usrpdv'), ['create'], ['class' => 'btn btn-success']) ?>
    </p>

    <?= GridView::widget([
        'dataProvider' => $dataProvider,
        'filterModel' => $searchModel,
        'columns' => [
            //['class' => 'yii\grid\SerialColumn'],

            'id',
            [
                'attribute'=>'user_id',
                'filter'=>$users,
                'value'=>function($data){
                    return $data->user->username;
                },
            ],
            [
                'attribute'=>'config_pdv_id',
                'filter'=>$pdvs,
                'value'=>function($data){
                    return $data->configpdv->name_pdv;
                },
            ],
            ['class' => 'yii\grid\ActionColumn'],
        ],
    ]); ?>
    </div>
</div>
